<?php
/**
 * appRain v 0.1.x
 *
 * LICENSE
 *
 * This source file is subject to the MIT license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/mit-license.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@apprain.com so we can send you a copy immediately.
 *
 * @copyright  Copyright (c) 2010 appRain, Team. (http://www.apprain.com)
 * @license    http://www.opensource.org/licenses/mit-license.php MIT license
 *
 * HELP
 *
 * Official Website
 * http://www.apprain.com/
 *
 * Download Link
 * http://www.apprain.com/download
 *
 * Documents Link
 * http ://www.apprain.com/docs
 */

class Development_Helper_Pgateway_Paypal extends appRain_Base_Objects
{
	const PAYPAL_URL = 'https://www.paypal.com/cgi-bin/webscr';
	const PAYPAL_SANDBOX_URL = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
	const PAYMENT_SUCCESS_URL = '/payment-success';
	const PAYMENT_FAILED_URL = '/payment-failed';
	const PAYMENT_NOTIFY_URL = '/appstore/paypalipn';
	const STATUS_NAME = 'Paypal';

	public function __construct()
	{

	}

	public function place()
	{
		echo App::Module("Cryptography")->jsonEncode(
													 Array(
															"_status" =>"Redirect",
															"_location"=> App::Helper('Config')->baseurl('/appstore/paypal-post')
															)
													 );
		exit;
	}

	public function getStatusName()
	{
		return self::STATUS_NAME;
	}

	public function submitPost()
	{
		$this->setCommonVars();

		$Config = App::Helper('Config');

		App::Plugin("Paypal_Standard")->add_field('business', $Config->siteInfo('paypal_payment_email'))
									  ->add_field('return', $Config->baseUrl(self::PAYMENT_SUCCESS_URL))
									  ->add_field('cancel_return', $Config->baseUrl(self::PAYMENT_FAILED_URL))
									  ->add_field('notify_url', $Config->baseUrl(self::PAYMENT_NOTIFY_URL))
									  ->add_field('currency_code', 'USD')
									  ->add_field('item_name', $Config->siteInfo('site_title'))
									  ->add_field('amount', App::Helper('appStore')->totalCost())
									  ->add_field('custom', App::Helper('appStore')->getOrderId())
									  ->submit_paypal_post();
	}

	public function ExecuteIPN()
	{
		$this->setCommonVars();

		if(App::Plugin("Paypal_Standard")->validate_ipn())
		{
			$orderid = App::Plugin("Paypal_Standard")->ipn_data['custom'];
			App::Helper("appStore")->setPaymentType('Paypal')
								   ->ChnageOrderStatus($orderid)
							       ->clearcart();
		}
	}

	public function setCommonVars()
	{
		if(App::Helper('Config')->siteInfo('paypal_mode') == 'Sandbox') App::Plugin("Paypal_Standard")->paypal_url = self::PAYPAL_SANDBOX_URL;
		else App::Plugin("Paypal_Standard")->paypal_url = self::PAYPAL_URL;

		return $this;
	}

    public function htmlToRender()
    {
        return $this->__("Paypal website standard payment");
    }
}