/**
 * appRain v 0.1.x
 *
 * LICENSE
 *
 * This source file is subject to the MIT license that is bundled
 * with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/mit-license.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@apprain.com so we can send you a copy immediately.
 *
 * @copyright  Copyright (c) 2010 appRain, Inc. (http://www.apprain.com)
 * @license    http://www.opensource.org/licenses/mit-license.php MIT license
 *
 * HELP
 *
 * Official Website
 * http://www.apprain.com/
 *
 * Download Link
 * http://www.apprain.com/download
 *
 * Documents Link
 * http ://www.apprain.com/docs
 */
var appcart =
{
	_minitem   :0,
	_buttonobj :null,
	_parentobj :null,
    _buttonref :'.add2cart-button',
	_parentref :'.add2cartwrapper',
	_unittref  :'.add2cart-input',
	_productref:'.productid',
	tqtycartref:'#tqtycart',
	_messageref:'cart-msg',
	_chkobtnref:'.checkout-button',
	_chkolink  :'/checkout',
	_delay	   :2000,
	_l_img     :base + '/images/loading.gif',
	loading    :function(ptr)
                {
					if(ptr) appcart._parentobj.setStyle('background','url(' + appcart._l_img + ') left center no-repeat');
                    else appcart._parentobj.setStyle('background','none');
                },
   getUnitTotal:function()
				 {
					var _obj  = appcart._parentobj.getChildren(appcart._unittref);
					var total = _obj.get('value');
					if(total < appcart._minitem || isNaN(total))
					{
						total = appcart._minitem;
						_obj.set('value',appcart._minitem);
					}

					return total;
				},
	getProdId  :function()
				{
					return  appcart._parentobj.getChildren(appcart._productref).get('value');
				},
	add2cart   :function()
				{
					appcart._buttonobj = this;
					appcart._parentobj = this.getParent();

					appcart.loading(true);
					new Request({url:base,
						onSuccess: function(responseTxt)
						{
							var responseObj = JSON.decode(responseTxt);
							$$(appcart.tqtycartref).set('text',responseObj.totalitem);
							appcart._parentobj.grab(new Element('div', {'class': appcart._messageref}).set('html',responseObj._message),'top');
							appcart.checkoutbtn(responseObj._hastocheckout);
							appcart.clearmsg.delay(appcart._delay);
							appcart.loading(false);
						},
						onFailure: function() {alert("Check your connection.");}
					}).send({url:base + "/appstore/add2qcart/" + appcart.getProdId() + "/" + appcart.getUnitTotal() +  "?ajax=true"});
				},
	checkoutbtn:function(F)
				{
					$$(appcart._chkobtnref).removeClass('hide');
					$$(appcart._chkobtnref).removeClass('show');

					if(F)
					{

						$$(appcart._chkobtnref).addClass('show');
					}
					else
					{
						$$(appcart._chkobtnref).addClass('hide');
					}
				},
	checkout   :function()
				{
					window.location = base + appcart._chkolink;
				},
	clearmsg   :function()
				{
					$$('.cart-msg').dispose();
				},
    init       :function()
                {
					$$(appcart._chkobtnref).addEvent('click', appcart.checkout);
					$$(appcart._buttonref).addEvent('click', appcart.add2cart);
                }
}

window.addEvent('load', appcart.init);